/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.TInputParam.TInputParamPath;
import de.ship.db.tables.TInputType.TInputTypePath;
import de.ship.db.tables.TInputTypeparamlist.TInputTypeparamlistPath;
import de.ship.db.tables.records.TInputTypeparamRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputTypeparam extends TableImpl<TInputTypeparamRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_typeparam</code>
     */
    public static final TInputTypeparam T_INPUT_TYPEPARAM = new TInputTypeparam();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputTypeparamRecord> getRecordType() {
        return TInputTypeparamRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_typeparam.pk_input_typeparam</code>.
     */
    public final TableField<TInputTypeparamRecord, Integer> PK_INPUT_TYPEPARAM = createField(DSL.name("pk_input_typeparam"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_typeparam.fk_inputtype</code>.
     */
    public final TableField<TInputTypeparamRecord, Integer> FK_INPUTTYPE = createField(DSL.name("fk_inputtype"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_typeparam.inputtype_param</code>.
     * param of this input type
     */
    public final TableField<TInputTypeparamRecord, Integer> INPUTTYPE_PARAM = createField(DSL.name("inputtype_param"), SQLDataType.INTEGER.nullable(false), this, "param of this input type");

    /**
     * The column <code>common_dd.t_input_typeparam.inputtype_paramkey</code>.
     * language key of this input type param
     */
    public final TableField<TInputTypeparamRecord, String> INPUTTYPE_PARAMKEY = createField(DSL.name("inputtype_paramkey"), SQLDataType.CLOB.nullable(false), this, "language key of this input type param");

    /**
     * The column <code>common_dd.t_input_typeparam.lastchange</code>.
     */
    public final TableField<TInputTypeparamRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TInputTypeparam(Name alias, Table<TInputTypeparamRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputTypeparam(Name alias, Table<TInputTypeparamRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_typeparam</code> table
     * reference
     */
    public TInputTypeparam(String alias) {
        this(DSL.name(alias), T_INPUT_TYPEPARAM);
    }

    /**
     * Create an aliased <code>common_dd.t_input_typeparam</code> table
     * reference
     */
    public TInputTypeparam(Name alias) {
        this(alias, T_INPUT_TYPEPARAM);
    }

    /**
     * Create a <code>common_dd.t_input_typeparam</code> table reference
     */
    public TInputTypeparam() {
        this(DSL.name("t_input_typeparam"), null);
    }

    public <O extends Record> TInputTypeparam(Table<O> path, ForeignKey<O, TInputTypeparamRecord> childPath, InverseForeignKey<O, TInputTypeparamRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_TYPEPARAM);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputTypeparamPath extends TInputTypeparam implements Path<TInputTypeparamRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputTypeparamPath(Table<O> path, ForeignKey<O, TInputTypeparamRecord> childPath, InverseForeignKey<O, TInputTypeparamRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputTypeparamPath(Name alias, Table<TInputTypeparamRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputTypeparamPath as(String alias) {
            return new TInputTypeparamPath(DSL.name(alias), this);
        }

        @Override
        public TInputTypeparamPath as(Name alias) {
            return new TInputTypeparamPath(alias, this);
        }

        @Override
        public TInputTypeparamPath as(Table<?> alias) {
            return new TInputTypeparamPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputTypeparamRecord, Integer> getIdentity() {
        return (Identity<TInputTypeparamRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputTypeparamRecord> getPrimaryKey() {
        return Keys.PK_INPUT_TYPEPARAM;
    }

    @Override
    public List<UniqueKey<TInputTypeparamRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_TYPEPARAM);
    }

    @Override
    public List<ForeignKey<TInputTypeparamRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_TYPEPARAM__FK_INPUTTYPEPARAM_INPUTTYPE, Keys.T_INPUT_TYPEPARAM__FK_INPUTTYPEPARAM_DESCR);
    }

    private transient TInputTypePath _tInputType;

    /**
     * Get the implicit join path to the <code>common_dd.t_input_type</code>
     * table.
     */
    public TInputTypePath tInputType() {
        if (_tInputType == null)
            _tInputType = new TInputTypePath(this, Keys.T_INPUT_TYPEPARAM__FK_INPUTTYPEPARAM_INPUTTYPE, null);

        return _tInputType;
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_INPUT_TYPEPARAM__FK_INPUTTYPEPARAM_DESCR, null);

        return _tCoreTranslationKey;
    }

    private transient TInputParamPath _tInputParam;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_param</code> table
     */
    public TInputParamPath tInputParam() {
        if (_tInputParam == null)
            _tInputParam = new TInputParamPath(this, null, Keys.T_INPUT_PARAM__FK_INPUTPARAM_TYPEPARAM.getInverseKey());

        return _tInputParam;
    }

    private transient TInputTypeparamlistPath _tInputTypeparamlist;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_typeparamlist</code> table
     */
    public TInputTypeparamlistPath tInputTypeparamlist() {
        if (_tInputTypeparamlist == null)
            _tInputTypeparamlist = new TInputTypeparamlistPath(this, null, Keys.T_INPUT_TYPEPARAMLIST__FK_INPUTTYPEPARAMLIST_REF.getInverseKey());

        return _tInputTypeparamlist;
    }

    @Override
    public TInputTypeparam as(String alias) {
        return new TInputTypeparam(DSL.name(alias), this);
    }

    @Override
    public TInputTypeparam as(Name alias) {
        return new TInputTypeparam(alias, this);
    }

    @Override
    public TInputTypeparam as(Table<?> alias) {
        return new TInputTypeparam(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputTypeparam rename(String name) {
        return new TInputTypeparam(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputTypeparam rename(Name name) {
        return new TInputTypeparam(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputTypeparam rename(Table<?> name) {
        return new TInputTypeparam(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparam where(Condition condition) {
        return new TInputTypeparam(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparam where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparam where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparam where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputTypeparam where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputTypeparam where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputTypeparam where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputTypeparam where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparam whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparam whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
